;; AI Final Project
;; Module: main loader
;; CSC 466 - Graci
;; Jacob Peck - 20110425

;; utility code
(load "utils.l")

;; cellular automata code
(load "ca.l")

;; l-system code
(load "lsystem.l")

;; l-cells
(load "lcell.l")

;; composition
(load "composition.l")

;; genetics
(load "genetics-individual.l")
(load "genetics-population-copy.l")
(load "lsystem-mutation.l")
(load "lsystem-crossover.l")
(load "lsystem-fitness.l")
(load "genetics-algorithm.l")

;; UI
(load "alm-ui.l")

;; auto-start the UI, unless *DELAY-START* is t
(setf *DELAY-START* NIL)
(if (not *DELAY-START*) (alm))
